Patchwork [1/2,qemu-iotests] add sub-cluster allocating write test for sparse image formats

login
register
mail settings
Submitter Stefan Hajnoczi
Date Oct. 14, 2010, 1:30 p.m.
Message ID <1287063006-7131-1-git-send-email-stefanha@linux.vnet.ibm.com>
Download mbox | patch
Permalink /patch/67824/
State New
Headers show

Comments

Stefan Hajnoczi - Oct. 14, 2010, 1:30 p.m.
Image formats that grow the image file on demand and are organized into
clusters must handle sub-cluster allocating writes.  Such writes touch
a portion of a previously unallocated data cluster.  After the image
file is grown with the written data, reads of that cluster should work
as expected:

1. Sectors before the written region are zero.
2. The written region is present and the data is uncorrupted.
3. Sectors after the written region are zero.

Signed-off-by: Stefan Hajnoczi <stefanha@linux.vnet.ibm.com>
---
 027     |   77 +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 027.out |   23 ++++++++++++++++++
 group   |    1 +
 3 files changed, 101 insertions(+), 0 deletions(-)
 create mode 100755 027
 create mode 100644 027.out
Christoph Hellwig - Oct. 15, 2010, 3 p.m.
Thanks, I've applied both patches.

Btw, do you have any plans to add qed support to qemu-iotests?
Stefan Hajnoczi - Oct. 15, 2010, 4:46 p.m.
On Fri, Oct 15, 2010 at 4:00 PM, Christoph Hellwig <hch@lst.de> wrote:
> Thanks, I've applied both patches.
>
> Btw, do you have any plans to add qed support to qemu-iotests?

Yes, I have a qemu-iotests qed branch here:

http://repo.or.cz/w/qemu-iotests/stefanha.git/shortlog/refs/heads/qed

I'm going to update that branch and send out latest patches to add qed
in the appropriate places.

Stefan

Patch

diff --git a/027 b/027
new file mode 100755
index 0000000..67ecffc
--- /dev/null
+++ b/027
@@ -0,0 +1,77 @@ 
+#!/bin/bash
+#
+# Test that sub-cluster allocating writes zero the rest of the cluster
+#
+# Copyright (C) 2010 IBM, Corp.
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program.  If not, see <http://www.gnu.org/licenses/>.
+#
+
+# creator
+owner=stefanha@linux.vnet.ibm.com
+
+seq=`basename $0`
+echo "QA output created by $seq"
+
+here=`pwd`
+tmp=/tmp/$$
+status=1	# failure is the default!
+
+_cleanup()
+{
+	_cleanup_test_img
+}
+trap "_cleanup; exit \$status" 0 1 2 3 15
+
+# get standard environment, filters and checks
+. ./common.rc
+. ./common.filter
+
+_supported_fmt vmdk qcow qcow2
+_supported_os Linux
+
+
+size=128M
+cluster_size=65536
+subcluster_offset=1024
+subcluster_size=2048
+_make_test_img $size
+
+# This first write causes an L2 table to be allocated so that the next write
+# doesn't need to allocate one and is therefore at the end of the image file.
+# Otherwise an L2 table could get in the way after the data cluster.
+echo
+echo "== writing first cluster to populate metadata =="
+$QEMU_IO -c "write -pP 0xde $cluster_size $cluster_size" $TEST_IMG | _filter_qemu_io
+
+echo
+echo "== writing at sub-cluster granularity =="
+$QEMU_IO -c "write -pP 0xa $subcluster_offset $subcluster_size" $TEST_IMG | _filter_qemu_io
+
+echo
+echo "== verify pattern =="
+$QEMU_IO -c "read -pP 0xa $subcluster_offset $subcluster_size" $TEST_IMG | _filter_qemu_io
+
+echo
+echo "== verify zeroes before sub-cluster pattern =="
+$QEMU_IO -c "read -pP 0 -l $subcluster_offset 0 $subcluster_size" $TEST_IMG | _filter_qemu_io
+
+echo
+echo "== verify zeroes after sub-cluster pattern =="
+$QEMU_IO -c "read -pP 0 -l 512 -s $subcluster_size $subcluster_offset $(( subcluster_size + 512 ))" $TEST_IMG | _filter_qemu_io
+
+# success, all done
+echo "*** done"
+rm -f $seq.full
+status=0
diff --git a/027.out b/027.out
new file mode 100644
index 0000000..a45c303
--- /dev/null
+++ b/027.out
@@ -0,0 +1,23 @@ 
+QA output created by 027
+Formatting 'TEST_DIR/t.IMGFMT', fmt=IMGFMT size=134217728 
+
+== writing first cluster to populate metadata ==
+wrote 65536/65536 bytes at offset 65536
+64 KiB, X ops; XX:XX:XX.X (XXX YYY/sec and XXX ops/sec)
+
+== writing at sub-cluster granularity ==
+wrote 2048/2048 bytes at offset 1024
+2 KiB, X ops; XX:XX:XX.X (XXX YYY/sec and XXX ops/sec)
+
+== verify pattern ==
+read 2048/2048 bytes at offset 1024
+2 KiB, X ops; XX:XX:XX.X (XXX YYY/sec and XXX ops/sec)
+
+== verify zeroes before sub-cluster pattern ==
+read 2048/2048 bytes at offset 0
+2 KiB, X ops; XX:XX:XX.X (XXX YYY/sec and XXX ops/sec)
+
+== verify zeroes after sub-cluster pattern ==
+read 2560/2560 bytes at offset 1024
+2 KiB, X ops; XX:XX:XX.X (XXX YYY/sec and XXX ops/sec)
+*** done
diff --git a/group b/group
index 44581a9..4c8c419 100644
--- a/group
+++ b/group
@@ -33,3 +33,4 @@ 
 024 rw backing auto
 025 rw auto
 026 rw blkdbg auto
+027 rw auto